#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <stdio.h>
#include <string>
#include <vector>
#include <utility>
#include <algorithm>
#include "testlib.h"
#include <map>
#include <set>

std::map <std::pair <int, int>, int > g;

int main(int argc, char **argv)
{
	registerTestlibCmd(argc, argv);
	int n = inf.readInt();
	int m = inf.readInt();
	for (int i = 0; i < m; i++) {
		int a = inf.readInt();
		int b = inf.readInt();
		int c = inf.readInt();
		g[std::pair <int, int>(a, b)] = c;
		g[std::pair <int, int>(b, a)] = c;
	}
	int jans = ans.readInt();
	int oans = ouf.readInt();
	if (jans != oans)
		quitf(_wa, "Not optimal");
	int ocnt = ouf.readInt();
	int sum = 0;
	std::vector <int> cities;
	for (int i = 0; i < ocnt + 1; i++) 
		cities.push_back(ouf.readInt());
	if (cities[0] != 1 || cities[ocnt] != n)
		quitf(_wa, "Bad begin/end city");
	std::set <std::pair <int, int> > path;

	for (int i = 0; i < ocnt; i++) {
		int a = cities[i];
		int b = cities[i + 1];
		if (g.find(std::pair <int, int>(a, b)) == g.end())
			quitf(_wa, "Cities not connected");
		sum += g[std::make_pair(a, b)];
		path.insert(std::make_pair(a, b));
		path.insert(std::make_pair(b, a));
	}
	int f = ouf.readInt();
	int s = ouf.readInt();
	if (path.find(std::make_pair(f, s)) == path.end()) 
		quitf(_wa, "Bad free segment");
	sum -= g[std::make_pair(f, s)];
	if (sum != oans)
		quitf(_wa, "Answer doen't match sum of all segments");
	quitf(_ok, "OK!");
	return 0;
}
